



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Jackson - Quickstart</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Jackson - Quickstart</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 08:52:51 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>JSON Three Ways</h2>
<p>Jackson offers three alternative methods (one with two variants) for processing JSON:</p>
<ul><li><p><a href="http://wiki.fasterxml.com/JacksonStreamingApi" rel="external nofollow noreferrer">Streaming API</a>&nbsp;(aka "Incremental parsing/generation") reads and writes JSON content as discrete events.</p>
<ul><li><p><tt>org.codehaus.jackson</tt>.<a href="http://wiki.fasterxml.com/JsonParser" rel="external nofollow noreferrer">JsonParser</a>&nbsp;reads,&nbsp;<tt>org.codehaus.jackson</tt>.<a href="http://wiki.fasterxml.com/JsonGenerator" rel="external nofollow noreferrer">JsonGenerator</a>&nbsp;writes.</p></li>
<li><p>Inspired by the&nbsp;<a href="http://www.jcp.org/en/jsr/detail?id=173" rel="external nofollow noreferrer">StAX</a>&nbsp;API.</p></li></ul></li>
<li><p><a href="http://wiki.fasterxml.com/JacksonTreeModel" rel="external nofollow noreferrer">Tree Model</a>&nbsp;provides a mutable in-memory tree representation of a JSON document.</p>
<ul><li><p><tt>org.codehaus.jackson.map</tt>.<a href="http://wiki.fasterxml.com/ObjectMapper" rel="external nofollow noreferrer">ObjectMapper</a>&nbsp;can build trees; trees consist of&nbsp;<a href="http://wiki.fasterxml.com/JsonNode" rel="external nofollow noreferrer">JsonNode</a>&nbsp;nodes.</p></li>
<li>The tree model is similar to the XML DOM.</li></ul></li>
<li><p><a href="http://wiki.fasterxml.com/JacksonDataBinding" rel="external nofollow noreferrer">Data Binding</a>&nbsp;converts JSON to and from POJOs based either on property accessor conventions or annotations.</p>
<ul><li><p>There are&nbsp;<em>two variants</em>:&nbsp;<em>simple</em>&nbsp;and&nbsp;<em>full</em>&nbsp;data binding</p>
<ul><li><p><strong>Simple data binding</strong>&nbsp;means converting to and from Java Maps, Lists, Strings, Numbers, Booleans and nulls</p></li>
<li><p><strong>Full data binding</strong>&nbsp;means converting to and from any Java bean type (as well as "simple" types mentioned above)</p></li></ul></li>
<li><p><tt>org.codehaus.jackson.map</tt>.<a href="http://wiki.fasterxml.com/ObjectMapper" rel="external nofollow noreferrer">ObjectMapper</a>&nbsp;performs the marshalling (writing JSON) and unmarshalling (reading JSON) for both variants.</p></li>
<li><p>Inspired by the annotation-based (code-first) variant of&nbsp;<a href="http://www.jcp.org/en/jsr/detail?id=222" rel="external nofollow noreferrer">JAXB</a>.</p></li></ul></li></ul>
<p>From usage perspective, one way to summarize these 3 methods is:</p>
<ul><li><p><a href="http://wiki.fasterxml.com/JacksonStreamingApi" rel="external nofollow noreferrer">Streaming API</a>&nbsp;is best performing (lowest overhead, fastest read/write; other 2 methods build on it)</p></li>
<li><p><a href="http://wiki.fasterxml.com/JacksonDataBinding" rel="external nofollow noreferrer">Data Binding</a>&nbsp;is often most convenient</p></li>
<li><p><a href="http://wiki.fasterxml.com/JacksonTreeModel" rel="external nofollow noreferrer">Tree Model</a>&nbsp;is most flexible</p></li></ul>
<p>Given these properties, let's consider these in the reverse order, starting with what is usually the most natural and convenient method for Java developers:&nbsp;<a href="http://wiki.fasterxml.com/JacksonDataBinding" rel="external nofollow noreferrer">Jackson Data Binding API</a>.</p>
<h2>Examples</h2>
<h3>Full Data Binding (POJO) Example</h3>
<p>Jackson's&nbsp;<tt>org.codehaus.jackson.map.ObjectMapper</tt>&nbsp;"just works" for mapping JSON data into plain old Java objects ("POJOs"). For example, given JSON data</p>
<div>
<pre class="prettyprint linenums">{<br />
  "name" : { "first" : "Joe", "last" : "Sixpack" },<br />
  "gender" : "MALE",<br />
  "verified" : false,<br />
  "userImage" : "Rm9vYmFyIQ=="<br />
}</pre>
</div>
<p>It takes two lines of Java to turn it into a&nbsp;<tt>User</tt>&nbsp;instance:</p>
<div>
<pre class="prettyprint linenums">ObjectMapper mapper = new ObjectMapper(); // can reuse, share globally<br />
User user = mapper.readValue(new File("user.json"), User.class);</pre>
</div>
<p>Where the&nbsp;<tt>User</tt>&nbsp;class looks something like this:</p>
<div>
<pre class="prettyprint linenums">public class User {<br />
    public enum Gender { MALE, FEMALE };

    public static class Name {<br />
      private String _first, _last;

      public String getFirst() { return _first; }<br />
      public String getLast() { return _last; }

      public void setFirst(String s) { _first = s; }<br />
      public void setLast(String s) { _last = s; }<br />
    }

    private Gender _gender;<br />
    private Name _name;<br />
    private boolean _isVerified;<br />
    private byte[] _userImage;

    public Name getName() { return _name; }<br />
    public boolean isVerified() { return _isVerified; }<br />
    public Gender getGender() { return _gender; }<br />
    public byte[] getUserImage() { return _userImage; }

    public void setName(Name n) { _name = n; }<br />
    public void setVerified(boolean b) { _isVerified = b; }<br />
    public void setGender(Gender g) { _gender = g; }<br />
    public void setUserImage(byte[] b) { _userImage = b; }<br />
}</pre>
</div>
<p>Marshalling back to JSON is similarly straightforward:</p>
<div>
<pre class="prettyprint linenums">mapper.writeValue(new File("user-modified.json"), user);</pre>
</div>
<p>For fancier data binding (e.g., unmarshalling formatted dates into&nbsp;<tt>java.util.Date</tt>), Jackson provides annotations to customize the marshalling and unmarshalling process.</p>
<h3>"Raw" Data Binding Example</h3>
<p>(also known as "Untyped", or sometimes "simple" data binding)</p>
<p>In cases where you do not have (and don't want to create) specific Java classes to bind JSON to/from, "Untyped data binding" may be a better approach. It is used same way as full data binding, except that the formal binding type is specified simply as&nbsp;<strong>Object.class</strong>&nbsp;(or&nbsp;<strong>Map.class</strong>,&nbsp;<strong>List.class</strong>,&nbsp;<strong>String[].class</strong>&nbsp;if more specific typing is wanted). So the earlier binding of JSON that represent User data could have been done by:</p>
<div>
<pre class="prettyprint linenums">Map&lt;String,Object&gt; userData = mapper.readValue(new File("user.json"), Map.class);</pre>
</div>
<p>and userData would be like one we would explicit construct by:</p>
<div>
<pre class="prettyprint linenums">Map&lt;String,Object&gt; userData = new HashMap&lt;String,Object&gt;();<br />
Map&lt;String,String&gt; nameStruct = new HashMap&lt;String,String&gt;();<br />
nameStruct.put("first", "Joe");<br />
nameStruct.put("last", "Sixpack");<br />
userData.put("name", nameStruct);<br />
userData.put("gender", "MALE");<br />
userData.put("verified", Boolean.FALSE);<br />
userData.put("userImage", "Rm9vYmFyIQ==");</pre>
</div>
<p>This obviously works both ways: if you did construct such a Map (or bind from JSON and modify), you could write out just as before, by:</p>
<div>
<pre class="prettyprint linenums">mapper.writeValue(new File("user-modified.json"), userData);</pre>
</div>
<p>How does this work? By specifying&nbsp;<tt>Map.class</tt>, we do not specify generic key/value types. But&nbsp;<tt>ObjectMapper</tt>&nbsp;does know how to bind JSON data to and from Maps (and Lists, arrays, wrapper types), and does just that. Fundamentally JSON data has no "real" type as far as Jackson is concerned -- if it can be properly mapped to a type you give, it will be mapped.</p>
<p>Concrete Java types that Jackson will use for simple data binding are:</p>
<table>
<tbody>
<tr>
<td><strong>&nbsp;JSON Type&nbsp;</strong></td>
<td><strong>Java Type</strong></td>
</tr>
<tr>
<td>&nbsp;object</td>
<td>&nbsp;LinkedHashMap&lt;String,Object&gt;</td>
</tr>
<tr>
<td>&nbsp;array</td>
<td>&nbsp;ArrayList&lt;Object&gt;&nbsp;</td>
</tr>
<tr>
<td>&nbsp;string</td>
<td>&nbsp;String</td>
</tr>
<tr>
<td>&nbsp;number&nbsp;(no&nbsp;fraction )</td>
<td>&nbsp;<tt>Integer</tt>,&nbsp;<tt>Long</tt>&nbsp;or&nbsp;<tt>BigInteger</tt>&nbsp;(smallest applicable)</td>
</tr>
<tr>
<td>&nbsp;number&nbsp;(fraction)</td>
<td>&nbsp;<tt>Double</tt>&nbsp;(configurable to use&nbsp;<tt>BigDecimal</tt>)</td>
</tr>
<tr>
<td>&nbsp;true|false</td>
<td>&nbsp;Boolean</td>
</tr>
<tr>
<td>&nbsp;null</td>
<td>&nbsp;null</td>
</tr>
</tbody>
</table>
<h3>Data Binding with Generics</h3>
<p>In addition to binding to POJOs and "simple" types, there is one additional variant: that of binding to generic (typed) containers.&nbsp;This case requires special handling due to so-called Type Erasure (used by Java to implement generics in somewhat backwards compatible way), which prevents you from using something like&nbsp;<tt>Collection&lt;String&gt;.class</tt>&nbsp;(which does not compile).</p>
<p>So if you want to bind data into a&nbsp;<tt>Map&lt;String,User&gt;</tt>&nbsp;you will need to use:</p>
<div>
<pre class="prettyprint linenums">Map&lt;String,User&gt; result = mapper.readValue(src, new TypeReference&lt;Map&lt;String,User&gt;&gt;() { });</pre>
</div>
<p>where&nbsp;<tt>TypeReference</tt>&nbsp;is only needed to pass generic type definition (via anynomous inner class in this case): the important part is&nbsp;<tt>&lt;Map&lt;String,User&gt;&gt;</tt>&nbsp;which defines type to bind to.</p>
<p>If you don't do this (and just pass&nbsp;<tt>Map.class</tt>), call is equivalent to binding to&nbsp;<tt>Map&lt;?,?&gt;</tt>&nbsp;(i.e. "untyped" Map), as explained above.</p>
<p>UPDATE: As an alternative,&nbsp;<a href="http://wiki.fasterxml.com/JacksonRelease13" rel="external nofollow noreferrer">version 1.3</a>&nbsp;also allows programmatic construction of types by using&nbsp;<tt>TypeFactory</tt>.</p>
<h3>Tree Model Example</h3>
<p>Yet another way to get Objects out of JSON is to build a tree. This is similar to DOM trees for XML. The way Jackson builds trees is to use basic&nbsp;<tt>JsonNode</tt>&nbsp;base class, which exposes read access that is usually needed. Actual node types used are sub-classes; but the sub-type only needs to be used when modifying trees.</p>
<p>Trees can be read and written using either Streaming API (see below), or using&nbsp;<tt>ObjectMapper</tt>.</p>
<p>With&nbsp;<tt>ObjectMapper</tt>, you will do something like:</p>
<div>
<pre class="prettyprint linenums">ObjectMapper m = new ObjectMapper();<br />
// can either use mapper.readTree(source), or mapper.readValue(source, JsonNode.class);<br />
JsonNode rootNode = m.readTree(new File("user.json"));<br />
// ensure that "last name" isn't "Xmler"; if is, change to "Jsoner"<br />
JsonNode nameNode = rootNode.path("name");<br />
String lastName = nameNode.path("last").getTextValue().<br />
if ("xmler".equalsIgnoreCase(lastName)) {<br />
  ((ObjectNode)nameNode).put("last", "Jsoner");<br />
}<br />
// and write it out:<br />
m.writeValue(new File("user-modified.json"), rootNode);</pre>
</div>
<p>Or if you want to construct a Tree (for the User example) from scratch, you can do:</p>
<div>
<pre class="prettyprint linenums">TreeMapper treeMapper = new TreeMapper();<br />
ObjectNode userOb = treeMapper.objectNode();<br />
Object nameOb = userRoot.putObject("name");<br />
nameOb.put("first", "Joe");<br />
nameOb.put("last", "Sixpack");<br />
userOb.put("gender", User.Gender.MALE.toString());<br />
userOb.put("verified", false);<br />
byte[] imageData = getImageData(); // or wherever it comes from<br />
userOb.put("userImage", imageData);</pre>
</div>
<p>(NOTE: with Jackson 1.2 you can use&nbsp;<a href="http://wiki.fasterxml.com/ObjectMapper" rel="external nofollow noreferrer">ObjectMapper</a>&nbsp;directly, using&nbsp;<a href="http://wiki.fasterxml.com/ObjectMapper" rel="external nofollow noreferrer">ObjectMapper</a>.createObjectNode() to create userOb -- above example will work with JAckson 1.0 and 1.1)</p>
<h3>Streaming API Example</h3>
<p>And finally, there is the third way: turbo-charged, high-performance method known as Streaming API (aka incremental mode, since content is read and written incrementally).</p>
<p>Just for fun, let's implement the writing functionality (equivalent to earlier examples) using "raw" Streaming API: WriteJSON.java</p>
<div>
<pre class="prettyprint linenums">JsonFactory f = new JsonFactory();<br />
JsonGenerator g = f.createJsonGenerator(new File("user.json"));

g.writeStartObject();<br />
g.writeObjectFieldStart("name");<br />
g.writeStringField("first", "Joe");<br />
g.writeStringField("last", "Sixpack");<br />
g.writeEndObject(); // for field 'name'<br />
g.writeStringField("gender", Gender.MALE);<br />
g.writeBooleanField("verified", false);<br />
g.writeFieldName("userImage"); // no 'writeBinaryField' (yet?)<br />
byte[] binaryData = ...;<br />
g.writeBinary(binaryData);<br />
g.writeEndObject();<br />
g.close(); // important: will force flushing of output, close underlying output stream</pre>
</div>
<p>Not horribly bad (esp. compared to amount of work needed for writing, say, equivalent XML content), but certainly more laborious than basic Object mapping.</p>
<p>On the other hand, you do have full control over each and every detail. And overhead is minimal: this is still a bit faster than using&nbsp;<tt>ObjectMapper</tt>; not a whole lot (perhaps 20-30% faster in common cases), but still. And perhaps most importantly, output is done in streaming manner: except for some buffering, all content will be written out right away. This means that memory usage is also minimal.</p>
<p>How about parsing, then? Code could look something like:</p>
<div>
<pre class="prettyprint linenums">JsonFactory f = new JsonFactory();<br />
JsonParser jp = f.createJsonParser(new File("user.json"));<br />
User user = new User();<br />
jp.nextToken(); // will return JsonToken.START_OBJECT (verify?)<br />
while (jp.nextToken() != JsonToken.END_OBJECT) {<br />
  String fieldname = jp.getCurrentName();<br />
  jp.nextToken(); // move to value, or START_OBJECT/START_ARRAY<br />
  if ("name".equals(fieldname)) { // contains an object<br />
    Name name = new Name();<br />
    while (jp.nextToken() != JsonToken.END_OBJECT) {<br />
      String namefield = jp.getCurrentName();<br />
      jp.nextToken(); // move to value<br />
      if ("first".equals(namefield)) {<br />
        name.setFirst(jp.getText());<br />
      } else if ("last".equals(namefield)) {<br />
        name.setLast(jp.getText());<br />
      } else {<br />
        throw new IllegalStateException("Unrecognized field '"+fieldname+"'!");<br />
      }<br />
    }<br />
    user.setName(name);<br />
  } else if ("gender".equals(fieldname)) {<br />
    user.setGender(User.Gender.valueOf(jp.getText()));<br />
  } else if ("verified".equals(fieldname)) {<br />
    user.setVerified(jp.getCurrentToken() == JsonToken.VALUE_TRUE);<br />
  } else if ("userImage".equals(fieldname)) {<br />
    user.setUserImage(jp.getBinaryValue());<br />
  } else {<br />
    throw new IllegalStateException("Unrecognized field '"+fieldname+"'!");<br />
  }<br />
}<br />
jp.close(); // ensure resources get cleaned up timely and properly</pre>
</div>
<p>which is quite a bit more than you'll use with data binding.</p>
<p>One final trick: it is also possible to use data binding and tree model directly from&nbsp;<tt>JsonParser</tt>&nbsp;and&nbsp;<tt>JsonGenerator</tt>. To do this, have a look at methods:</p>
<ul><li><p><tt>JsonParser.readValueAs()</tt></p></li>
<li><p><tt>JsonParser.readValueAsTree()</tt></p></li>
<li><p><tt>JsonGenerator.writeObject()</tt></p></li>
<li><p><tt>JsonGenerator.writeTree()</tt></p></li></ul>
<p>which do about what you might expect them to do.</p>
<p>The only (?) trick is that you MUST make sure you use&nbsp;<tt>org.codehaus.jackson.map.MappingJsonFactory</tt>&nbsp;for constructing "data-binding capable" parser and generator instances (instead of basic&nbsp;<tt>org.codehaus.jackson.JsonFactory</tt>).</p>
<h3>Streaming API Example 2: arrays</h3>
<p>Let's consider following POJO:</p>
<div>
<pre class="prettyprint linenums">public class Foo {<br />
    public String foo;<br />
}</pre>
</div>
<p>and sample JSON stream of:</p>
<div>
<pre class="prettyprint linenums">String json = [{\"foo\": \"bar\"},{\"foo\": \"biz\"}]";</pre>
</div>
<p>while there are convenient ways to work on this with databinding (see&nbsp;<a href="http://wiki.fasterxml.com/ObjectReader" rel="external nofollow noreferrer">ObjectReader</a>.<tt>readValues()</tt>&nbsp;for details), you can easily use streaming to iterate over stream, bind individual elements as well:</p>
<div>
<pre class="prettyprint linenums">JsonFactory f = new JsonFactory();<br />
JsonParser jp = f.createJsonParser(json);<br />
// advance stream to START_ARRAY first:<br />
jp.nextToken();<br />
// and then each time, advance to opening START_OBJECT<br />
while (jp.nextToken() == JsonToken.START_OBJECT) {<br />
    Foo foobar = mapper.readValue(jp, Foo.class);<br />
    // process<br />
    // after binding, stream points to closing END_OBJECT<br />
}</pre>
</div>
<h3>Next Steps</h3>
<p>You may want to check out rest of&nbsp;<a href="http://wiki.fasterxml.com/JacksonDocumentation" rel="external nofollow noreferrer">JacksonDocumentation</a>&nbsp;for more inspiration.</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pm5k79.html">git学习（三）：版本控制</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx5j4v8.html">写自己的ASP&period;NET MVC框架（上）</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gz1lz8.html">mysql中的where和having子句的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0p4o0q.html">hdu 1284 钱币兑换问题 完全背包</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnvox0q.html">lfs遇到的一些问题--后续阶段</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z6j769.html">【数学相关、规律】Codeforces 696B Puzzles</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde23vx9.html">Asp&period;Net--下载文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdj6w78.html">Socket缓冲区探讨，是否有拆包的方式&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kzp6z9.html">输出特殊符号，可以用单引号&amp;&num;39&semi;引文&amp;&num;39&semi;：echo &amp;&num;39&semi;Hello World &excl;&amp;&num;39&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojpvelq.html">hibernate框架学习笔记6：事务</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp6gmj9.html">python3全栈开发-面向对象的三大特性（继承，多态，封装）之继承</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljdz7e9.html">&lbrack;HNOI 2016&rsqb;大数</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j173w8.html">【一天一道LeetCode】&num;95&period; Unique Binary Search Trees II</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyzeym9.html">spring kafka生产、消费消息</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojxm3eq.html">Python 第八阶段 学习记录之---算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy3v5v9.html">html 中a标签的问题（无反应，跳转，调用方法）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g7x06q.html">Dubbo注册Zookepper服务的虚拟IP</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjx3309.html">&lbrack;51nod1514&rsqb; 美妙的序列</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdmv1e9.html">当模版引擎遇到点&lpar;&amp;quot&semi;&period;&amp;quot&semi;&rpar;，会按照下列顺序查询：</a>
		</li>
						<li><a href="https://www.batexi.com/a/9027lznq.html">R语言学习 第四篇：函数和流程控制</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qdek37z9.html">Java学习笔记（七）：内部类、静态类和泛型</a>
			</li>
						<li><a href="https://www.batexi.com/a/96odkx39.html">TypeScript学习笔记（四）：函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydgnmjq.html">OpenNebula config配置详情</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oky0v59.html">教你50招提升ASP&period;NET性能（十八）：在处理网站性能问题前，首先验证问题是否出在客户端</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mdy4kq.html">leetcode第一刷&lowbar;Count and Say</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvkyeyq.html">极域电子教室 e-Learning Class V4 2010专业版 学生机 卸载方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/93x746n9.html">const 成员方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnyvv08.html">delphi 18 屏蔽和替换 右键菜单</a>
			</li>
						<li><a href="https://www.batexi.com/a/93x7ep09.html">PhpStorm&comma; XDebug&comma; and DBGp Proxy</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd7o748.html">SSO-Javascript模拟IE登录，不让IIS弹出登录窗口</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
